package org.zeroturnaround.javarebel.integration.elcommons;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.bundled.javassist.NotFoundException;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

public class BeanInfoManagerStandardLangCBP extends
		JavassistClassBytecodeProcessor {

	public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
		CtMethod m = null;
		try {
			m = 
				ctClass.getMethod(
			        "getProperty", 
			        "(Ljava/lang/String;Lorg/apache/taglibs/standard/lang/jstl/Logger;)Lorg/apache/taglibs/standard/lang/jstl/BeanInfoProperty;");
			
			m.setBody("{ checkInitialized($2);" + 
					"org.apache.taglibs.standard.lang.jstl.BeanInfoProperty beanInfoProperty = (org.apache.taglibs.standard.lang.jstl.BeanInfoProperty) mPropertyByName.get($1);" + 
	 
		    		"if (beanInfoProperty == null) {" +
		    		"    mInitialized = false;" + 
		    		"    java.beans.Introspector.flushFromCaches(mBeanClass);" + 
		    		"    this.checkInitialized($2);" + 
		    		"} " + 
		    		"return (org.apache.taglibs.standard.lang.jstl.BeanInfoProperty) mPropertyByName.get($1); }");
		}
		catch (NotFoundException e) {
		}
	}
}
